package com.dsic.gj_erp.pc.dto.data;

import cn.hutool.core.bean.BeanUtil;
import com.alibaba.fastjson.JSONObject;
import com.dsic.gj_erp.bean.jcsj.DmBom;
import com.dsic.gj_erp.pc.Constant;
import com.dsic.gj_erp.pc.dto.gx.*;
import com.dsic.gj_erp.pc.dto.sb.*;
import com.dsic.gj_erp.pc.dto.设备;
import com.dsic.gj_erp.pc.dto.资源;
import lombok.Getter;
import lombok.Setter;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

@Getter
@Setter
public class Bom {
    private String dcch;
    private String mbch;
    private String pl;
    private String _pl;//曲外板pl需要增加Q,这里
    private String fd;

    private String xzglxq;
    private String dzglxq;

    private String zl;
    private String kw;
    private String tzbh;
    private String wpgg;
    private String wpcz;
    private String ljsl;
    private Map<String,String> degs;
    private 设备 所在设备;
    private 资源 所在资源;
    private List<Constant.工序> 已排工序;
    private List<ErrorType> errors;

    public static Bom of(String xzxq, String dzxq, DmBom bom){
        Bom _bom = new Bom();
        BeanUtil.copyProperties(bom,_bom);
        _bom.xzglxq=xzxq;
        _bom.dzglxq=dzxq;
        _bom.已排工序 =new ArrayList<>();
        _bom.errors=new ArrayList<>();
        return _bom;
    }

    public String toString() {
        return JSONObject.toJSONString(this);
    }

    public void 坡口结束日期不满足大组需求期(){
        this.errors.add(ErrorType.坡口结束日期不满足大组需求期);
    }

    public void 没有订货(){
        this.errors.add(ErrorType.没有订货);
    }

    public void 订货计划到齐日期格式错误(){
        this.errors.add(ErrorType.订货计划到齐日期格式错误);
    }
    public void 上料之前无法到货(){
        this.errors.add(ErrorType.上料之前无法到货);
        this.errors.add(ErrorType.需求日期按照中日程计算);
    }

    public void 超出工序产能(Constant.工序 _工序){
        switch (_工序) {
            case 上料:
                this.errors.add(ErrorType.超出上料工序产能);
                break;
            case 抛丸:
                this.errors.add(ErrorType.超出抛丸工序产能);
                break;
            case 理料:
                this.errors.add(ErrorType.超出理料工序产能);
                break;
            case 划线:
                this.errors.add(ErrorType.超出划线工序产能);
                break;
            case 切割:
                this.errors.add(ErrorType.超出切割工序产能);
                break;
            case 坡口:
                this.errors.add(ErrorType.超出坡口工序产能);
                break;
            case 型材面板:
                this.errors.add(ErrorType.超出型材面板工序产能);
                break;
            case 曲型:
                this.errors.add(ErrorType.超出曲加工工序产能);
                break;
            case 打磨:
                this.errors.add(ErrorType.超出打磨工序产能);
                break;
            case 自由边处理:
                this.errors.add(ErrorType.超出自由边处理工序产能);
                break;
            case 光电结束:
                this.errors.add(ErrorType.超出光电工序产能);
                break;
        }
    }

    private enum ErrorType{
        坡口结束日期不满足大组需求期,
        没有订货,
        订货计划到齐日期格式错误,
        上料之前无法到货,
        需求日期按照中日程计算,
        超出上料工序产能,
        超出抛丸工序产能,
        超出理料工序产能,
        超出划线工序产能,
        超出切割工序产能,
        超出打磨工序产能,
        超出坡口工序产能,
        超出型材面板工序产能,
        超出曲加工工序产能,
        超出自由边处理工序产能,
        超出光电工序产能
    }
}
